import json

from axipy import init_axioma, AxiomaInitLogLevel, Geometry, CoordSystem, Feature, Attribute, Schema, provider_manager

from PkkInfo.ui.tools.PkkToolINfo import StructData


def getObjFromJson(obj_js,name):
    try:
        data_obj=obj_js[name]
        return data_obj
    except:
        return None
class StructDataZ:
    def __init__(self):
        self.__att_struct= {}
        self.__fetures=[]
        self.__def_cs=CoordSystem.from_epsg(3857)
    def add(self):
        pass
    def __propertiesInAtt(self,js_properties):
        out_values=[]
        for key in js_properties.keys():
            if key=='options':
                out_values.extend(self.__propertiesInAtt(js_properties[key]))
            out_values.append({key:js_properties[key]})
        return out_values
    def __addStructAtt(self,list_att_ft):
        for att in list_att_ft['att']:
            key=list(att.keys())[0]
            if key in self.__att_struct:
                continue
            value=att[key]
            if value is None or isinstance(value,str):
                self.__att_struct[key]='string'

                continue
            if isinstance(value,int):
                self.__att_struct[key] = 'integer'
                continue
            if isinstance(value, float):
                self.__att_struct[key]='double'
                continue
    def __prepareGeometry(self,js_geometry):
        str_geo_json=json.dumps(js_geometry)
        axi_geo=Geometry.from_geojson(str_geo_json)
        if axi_geo.coordsystem is None:
            axi_geo.coordsystem=self.__def_cs
        return axi_geo
    def __axiFeature(self,virt_feature):
        att={}
        for ft_att in virt_feature['att']:
            name=list(ft_att.keys())[0]
            value=ft_att[name]
            if value is None:
                continue
            att[name]=value
        ft=Feature(att,geometry=virt_feature['geometry'])
        return ft
    def prepareObj(self,json_obj):
        data=getObjFromJson(json_obj,'data')
        if data is None:
            return False
        type=getObjFromJson(data,'type')
        if type is None:
            return False
        if type.lower()!='featurecollection':
            return None
        source_features=getObjFromJson(data,'features')

        for ft in source_features:
            keys_ft=ft.keys()
            virtal_ft={'att':[],'geometry':None}
            for key in keys_ft:
                value_ft=ft[key]
                if key=='geometry':
                    virtal_ft['geometry']=self.__prepareGeometry(value_ft)
                else:
                    if key == 'type':
                        continue

                    if key=='properties':
                        virtal_ft['att'].extend(self.__propertiesInAtt(ft[key]))
                        continue
                    virtal_ft['att'].append({key: ft[key]})
            self.__addStructAtt(virtal_ft)
            self.__fetures.append(self.__axiFeature(virtal_ft))
    def getSchema(self):
        attrs=[]
        for att_key in self.__att_struct.keys():
            type=self.__att_struct[att_key]
            if type=='string':
                attrs.append(Attribute.string(att_key,255))
                continue
            if type=='double':
                attrs.append(Attribute.double(att_key))
                continue
            if type=='integer':
                attrs.append(Attribute.integer(att_key))
                continue
        return Schema(*attrs, coordsystem=self.__def_cs)
    def getFeatures(self):
        return self.__fetures
app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_json=r"E:\Download\RossRestr\NewSite\geoportal._3.json"
str_json=None
with open(path_json, 'r',encoding='utf-8') as file:
    str_json=file.read()
jkl=0
json_obj=json.loads(str_json)
cls_StructData=StructData()
cls_StructData.prepareObj(json_obj)
schema_tab=cls_StructData.getSchema()
path_out_tab=r"E:\Support\AxiomaTesting\NewPKK\test_2.tab"
tab=provider_manager.createfile(path_out_tab,schema_tab)
tab.insert(cls_StructData.getFeatures())
tab.commit()
tab.close()
jkl=0
app.exit()
