import urllib

import requests
from PySide2.QtCore import QObject
from loguru import logger


class HttpClientPkk(QObject):
    __base_url="https://nspd.gov.ru/api/geoportal/v2/search/geoportal?"
    __refer="https://nspd.gov.ru^"
    __headers = {
        'User-Agent': 'Mozilla/5.0',
        'Referer': 'https://example.com'
    }
    def __init__(self,callback=None):
        super().__init__()
        self.__headers['Referer']=self.__refer
        self.__callback=callback
        self.__count_request=3
    def __findObject(self,cad_number):
        url_request=self.__base_url+"thematicSearchId=1&query="+urllib.parse.quote(cad_number)
        responce=None
        try:
            #responce=response=requests.get(url_request,headers=self.__headers,timeout=3,verify=False)
            responce =  requests.get(url_request, headers=self.__headers, timeout=3, verify=False)
        except Exception as ex:
            logger.exception(ex)
        if not responce.ok:
            return None
        return responce.json()
    def getObject(self,cad_number):
        for i in range(self.__count_request):
            js_data=self.__findObject(cad_number)
            if js_data is not None:
                return js_data
            if self.__callback is not None:
                self.__callback("Попытка " + str(i))
        return None

